from typing import Any, Dict, List, Type, TypeVar, cast

import attr

T = TypeVar("T", bound="SubmissionIDs")


@attr.s(auto_attribs=True)
class SubmissionIDs:
    """
    Attributes:
        submission_ids (List[str]):
    """

    submission_ids: List[str]
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        submission_ids = self.submission_ids

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "submission_ids": submission_ids,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        submission_ids = cast(List[str], d.pop("submission_ids"))

        submission_i_ds = cls(
            submission_ids=submission_ids,
        )

        submission_i_ds.additional_properties = d
        return submission_i_ds

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
